#define OT4XB_MIN_VER "001.005.017.009"
#define _OT4XB_MAP_WAPIST_FUNC_
#include "ot4xb.ch"

#include "common.ch"

#define GUID_DEVINTERFACE_VOLUME     "{53f5630d-b6bf-11d0-94f2-00a0c91efb8b}"
#define GUID_DEVINTERFACE_DISK       "{53f56307-b6bf-11d0-94f2-00a0c91efb8b}"
#define GUID_DEVINTERFACE_FLOPPY     "{53f56311-b6bf-11d0-94f2-00a0c91efb8b}"
#define GUID_DEVINTERFACE_CDROM      "{53f56308-b6bf-11d0-94f2-00a0c91efb8b}"
#define GUID_DEVINTERFACE_USB_DEVICE "{A5DCBF10-6530-11D2-901F-00C04FB951ED}"

// https://msdn.microsoft.com/en-us/library/windows/hardware/ff552342%28v=vs.85%29.aspx
BEGIN STRUCTURE SP_DEVICE_INTERFACE_DATA
   MEMBER DWORD cbSize
   MEMBER @GUID InterfaceClassGuid
   MEMBER DWORD Flags
   MEMBER ULONG Reserved                        // ULONG_PTR
END STRUCTURE

// https://msdn.microsoft.com/en-us/library/windows/desktop/aa373931%28v=vs.85%29.aspx
BEGIN STRUCTURE GUID
   MEMBER DWORD Data1
   MEMBER WORD  Data2
   MEMBER WORD  Data3
   MEMBER BYTE  Data4                            // hm ...
END STRUCTURE

BEGIN STRUCTURE BYTEARRAY
   MEMBER BYTE _1OF2
   MEMBER BYTE _2OF2
   MEMBER BYTE _1OF6
   MEMBER BYTE _2OF6
   MEMBER BYTE _3OF6
   MEMBER BYTE _4OF6
   MEMBER BYTE _5OF6
   MEMBER BYTE _6OF6
END STRUCTURE

PROCEDURE MAIN()
LOCAL cGUID := GUID_DEVINTERFACE_DISK
LOCAL aGuid
LOCAL oByteArray
LOCAL aHex  := {}
LOCAL spdid := SP_DEVICE_INTERFACE_DATA():NEW()

   spdid:cbSize   := spdid:_sizeof_()

   // split cGUID String
   aGuid := guid2array(cGUID)

   CLS
?  "GUID",cGUID
?  ""
?  "split into Array Elements"
?  VAR2CHAR(aGuid)

   // assign to GUID Structure
   spdid:InterfaceClassGuid:Data1 := nHex2Dw( aGuid[1] )
   spdid:InterfaceClassGuid:Data2 := nHex2W(  aGuid[2] )
   spdid:InterfaceClassGuid:Data3 := nHex2W(  aGuid[3] )

   // try Array ... seems not to work
   //
   AADD(aHex, nHex2Byte(aGuid[4])  )
   AADD(aHex, nHex2Byte(aGuid[5])  )
   AADD(aHex, nHex2Byte(aGuid[6])  )
   AADD(aHex, nHex2Byte(aGuid[7])  )
   AADD(aHex, nHex2Byte(aGuid[8])  )
   AADD(aHex, nHex2Byte(aGuid[9])  )
   AADD(aHex, nHex2Byte(aGuid[10]) )
   AADD(aHex, nHex2Byte(aGuid[11]) )

?  ""
?  "try assign Array aHex to Data4"
?  VAR2CHAR(aHex)

?  spdid:InterfaceClassGuid:Data4 := aHex

*  // crash while cHex to big ...
*  //
*  cHex := aGuid[4] +;
*          aGuid[5] +;
*          aGuid[6] +;
*          aGuid[7] +;
*          aGuid[8] +;
*          aGuid[9] +;
*          aGuid[10]+;
*          aGuid[11]
*
*  spdid:InterfaceClassGuid:Data4 := nHex2Byte( cHex )

   // try own Structure
   //
   oByteArray := BYTEARRAY():NEW()
   oByteArray:_1OF2 := nHex2Byte(aGuid[4])
   oByteArray:_2OF2 := nHex2Byte(aGuid[5])
   oByteArray:_1OF6 := nHex2Byte(aGuid[6])
   oByteArray:_2OF6 := nHex2Byte(aGuid[7])
   oByteArray:_3OF6 := nHex2Byte(aGuid[8])
   oByteArray:_4OF6 := nHex2Byte(aGuid[9])
   oByteArray:_5OF6 := nHex2Byte(aGuid[10])
   oByteArray:_6OF6 := nHex2Byte(aGuid[11])

?  ""
?  "try assign Structure to Data4"
?  spdid:InterfaceClassGuid:Data4 := oByteArray

   // decode again
   //
   aGuid := {}
   AADD(aGuid, spdid:InterfaceClassGuid:Data1)
   AADD(aGuid, spdid:InterfaceClassGuid:Data2)
   AADD(aGuid, spdid:InterfaceClassGuid:Data3)
   AADD(aGuid, spdid:InterfaceClassGuid:Data4)

?  ""
?  "decode backward"
?  ""
?  VAR2CHAR(aGuid)

   array2guid(aGuid)

   ? ""
   WAIT

RETURN

FUNCTION guid2array(cGUID)
LOCAL aRet  := {}
LOCAL cWork := cGUID
LOCAL cRet  := ""

   cWork := STRTRAN(cWork,"{","")
   cWork := STRTRAN(cWork,"}","")

// 123456789012345678901234567890123456
// 53f56308-b6bf-11d0-94f2-00a0c91efb8b

   IF LEN(cWork) = 36                            //
      AADD(aRet,SUBSTR(cWork, 1, 8))             // Data1
      AADD(aRet,SUBSTR(cWork,10, 4))             // Data2
      AADD(aRet,SUBSTR(cWork,15, 4))             // Data3

      // this is for Data4[8]
      //
*     AADD(aRet,SUBSTR(cWork,20, 4))             // Data4 2 Bytes
*     AADD(aRet,SUBSTR(cWork,25,12))             // Data4 6 Bytes

      AADD(aRet,SUBSTR(cWork,20, 2))             // Data4 2 Bytes
      AADD(aRet,SUBSTR(cWork,22, 2))

      AADD(aRet,SUBSTR(cWork,25, 2))             // Data4 6 Bytes
      AADD(aRet,SUBSTR(cWork,27, 2))
      AADD(aRet,SUBSTR(cWork,27, 2))
      AADD(aRet,SUBSTR(cWork,31, 2))
      AADD(aRet,SUBSTR(cWork,33, 2))
      AADD(aRet,SUBSTR(cWork,35, 2))

   ENDIF

RETURN aRet


FUNCTION array2guid(aData)
LOCAL cRet := ""
LOCAL i
LOCAL xxx

ALTD()

// aData[1]- [2]-[3] -aData[4]
//
// 53f56308-b6bf-11d0-94f2-00a0c91efb8b

   IF LEN(aData) = 4
      cRet += cDw2Hex(aData[1])+"-"
      cRet += cW2Hex( aData[2])+"-"
      cRet += cW2Hex( aData[3])+"-"

      // how to handle Data4
      //
*     xxx := aData[4]
*     xxx := cDw2Hex(aData[4])
*     IF LEN(xxx) = 8
*        FOR i := 1 TO 8
*           cRet += cByte2Hex(SUBSTR(xxx,i,1))
*        NEXT
*     ENDIF

*     cRet += cByte2Hex(aData[4])
      cRet += cDw2Hex(  aData[4])

   ENDIF

   ? "Data1,Data2,Data3 are right but Data4 Group missing"
   ? ""
   ? cRet

RETURN cRet

*
*
*


